package org.agt.module.license.service.project;

import jakarta.validation.Valid;
import org.agt.framework.common.pojo.PageResult;
import org.agt.module.license.controller.admin.license.vo.ImportRespVO;
import org.agt.module.license.controller.admin.project.vo.ProjectImportRespVO;
import org.agt.module.license.controller.admin.project.vo.ProjectListReqVO;
import org.agt.module.license.controller.admin.project.vo.ProjectPageReqVO;
import org.agt.module.license.controller.admin.project.vo.ProjectRespVO;
import org.agt.module.license.controller.admin.project.vo.ProjectSaveReqVO;
import org.agt.module.license.dal.dataobject.project.ProjectDO;

import java.util.List;

/**
 * 项目 Service 接口
 *
 * @author 管理员
 */
public interface ProjectService {

    /**
     * 创建项目
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createProject(@Valid ProjectSaveReqVO createReqVO);

    /**
     * 更新项目
     *
     * @param updateReqVO 更新信息
     */
    void updateProject(@Valid ProjectSaveReqVO updateReqVO);

    /**
     * 删除项目
     *
     * @param id 编号
     */
    void deleteProject(Long id);

    /**
     * 获得项目
     *
     * @param id 编号
     * @return 项目
     */
    ProjectDO getProject(Long id);

    /**
     * 获得项目分页
     *
     * @param pageReqVO 分页查询
     * @return 项目分页
     */
    PageResult<ProjectRespVO> getProjectPage(ProjectPageReqVO pageReqVO);

    /**
     * 获得项目列表
     *
     * @param pageReqVO 列表查询
     * @return 项目列表
     */
    List<ProjectRespVO> getProjectList(ProjectListReqVO reqVO);

    /**
     * 校验项目名称是否唯一
     *
     * @param name 项目名称
     * @param id   项目id
     * @return 是否存在
     */
    Boolean validateProjectNameUnique(String name, Long id);

    /**
     * 校验项目编号是否唯一
     *
     * @param code 项目编号
     * @param id   项目id
     * @return 是否存在
     */
    Boolean validateProjectCodeUnique(String code, Long id);

    /**
     * 查询当前最大的sn号
     *
     * @return 最大sn号
     */
    Integer selectMaxCode();

    ImportRespVO importList(List<ProjectImportRespVO> list, Boolean updateSupport);

    List<ProjectRespVO> getLicenseProjects(ProjectListReqVO reqVO);
}